#declare Glossy = finish {specular 1 roughness 0.0001 reflection 0.13}
#declare DMFWood2 = 
texture {
 pigment 
  {wood
   turbulence 0.03
   octaves 4
   scale <0.05, .05, 1>
   color_map 
    {[0.00, 0.10 color red 0.52 green 0.37 blue 0.26
                 color red 0.52 green 0.37 blue 0.26]
     [0.10, 0.90 color red 0.52 green 0.37 blue 0.26
                 color red 0.42 green 0.26 blue 0.15]
     [0.90, 1.0  color red 0.42 green 0.26 blue 0.15
                 color red 0.42 green 0.26 blue 0.15]
    }
  }
	finish { Glossy }
}

#declare Glass3 = 
 texture
   {pigment
     {color red 0.98 green 0.98 blue 0.98 filter 0.9}
    finish 
     {ambient 0.1
      diffuse 0.1
      specular 0.8
      reflection 0.1
      refraction 0.9
      ior 1.45
      roughness 0.0003
      phong 1 phong_size 400
     }
   }

#declare Silver1_Colour = color  red 0.94 green 0.93 blue 0.83
#declare SilverFinish = finish {
    metallic
    ambient 0.25
    diffuse 0.65
    reflection 0.45
    brilliance 6
    phong 1
    phong_size 100
}


// Each of these looks good.  Slightly bluer as you go down
#declare Silver1 = texture {
    pigment { Silver1_Colour }
    finish { SilverFinish }
}
// This is the desk gadget (The swinging balls).
// Object type: World
// Name: Root
#declare Gadget =
      // Object type: Composite
      // Name: Gadget
      object
      {
         union
         {
            // Object type: Composite
            // Name: Frame
            object
            {
               union
               {
                  // Object type: Composite
                  // Name: Side1
                  object
                  {
                     union
                     {
                        // Object type: Cylinder
                        // Name: NoName
                        object
                        {
                           cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                           scale < 5, 100, 5 >
                           rotate < 90, 0, 60 >
                           translate < -45.027, 4.9841, -50 >
                        }
                        // Object type: Difference
                        // Name: Elbow1
                        object
                        {
                           difference
                           {
                              // Object type: Torus
                              // Name: NoName
                              object
                              {
                                 torus { 30, 10 }

                                 scale < 0.5, 0.5, 0.5 >
                                 rotate < 0, 0, 60 >
                                 translate < -37.617, 17.818, -50.128 >
                              }
                              // Object type: Box
                              // Name: NoName
                              object
                              {
                                 box { < 0, 0, 0 >, < 1, 1, 1 > }

                                 scale < 48.222, 17.945, 20.571 >
                                 rotate < 0, 0, 60 >
                                 translate < -42.015, -8.5109, -50.128 >
                              }
                              // Object type: Box
                              // Name: NoName
                              object
                              {
                                 box { < 0, 0, 0 >, < 1, 1, 1 > }

                                 scale < 20, 20, 47.873 >
                                 rotate < 1.7075e-06, -45.233, 60 >
                                 translate < -19.441, 31.41, -69.021 >
                              }
                           }
                        }
                        // Object type: Difference
                        // Name: Elbow1
                        object
                        {
                           difference
                           {
                              // Object type: Torus
                              // Name: NoName
                              object
                              {
                                 torus { 30, 10 }

                                 scale < 0.5, 0.5, 0.5 >
                                 rotate < -180, 0, 60 >
                                 translate < -37.62, 17.813, 50 >
                              }
                              // Object type: Box
                              // Name: NoName
                              object
                              {
                                 box { < 0, 0, 0 >, < 1, 1, 1 > }

                                 scale < 48.222, 17.945, 20.571 >
                                 rotate < -180, 0, 60 >
                                 translate < -58.223, 0.83987, 50 >
                              }
                              // Object type: Box
                              // Name: NoName
                              object
                              {
                                 box { < 0, 0, 0 >, < 1, 1, 1 > }

                                 scale < 20, 20, 47.873 >
                                 rotate < -180, 45.233, 60 >
                                 translate < -34.937, 40.349, 68.893 >
                              }
                           }
                        }
                        // Object type: Cylinder
                        // Name: NoName
                        object
                        {
                           cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                           scale < 4.9625, 34.027, 4.9625 >
                           rotate < 45, 0, -30 >
                           translate < -31.986, 27.572, -60 >
                        }
                        // Object type: Cylinder
                        // Name: NoName
                        object
                        {
                           cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                           scale < 4.909, 35, 4.909 >
                           rotate < -45, 0, -30 >
                           translate < -32.053, 27.456, 60 >
                        }
                        // Object type: Difference
                        // Name: Elbow2
                        object
                        {
                           difference
                           {
                              // Object type: Torus
                              // Name: NoName
                              object
                              {
                                 torus { 30, 10 }

                                 scale < 0.5, 0.5, 0.5 >
                                 rotate < 0, 45, -120 >
                                 translate < -24.889, 39.864, 24.734 >
                              }
                              // Object type: Box
                              // Name: NoName
                              object
                              {
                                 box { < 0, 0, 0 >, < 1, 1, 1 > }

                                 scale < 46.406, 15.152, 20.848 >
                                 rotate < -1.7075e-06, 45, -120 >
                                 translate < -23.779, 57.956, 41.265 >
                              }
                              // Object type: Box
                              // Name: NoName
                              object
                              {
                                 box { < 0, 0, 0 >, < 1, 1, 1 > }

                                 scale < 24.648, 20, 49.27 >
                                 rotate < 120, 90, 0 >
                                 translate < -18.266, 66.705, 24.853 >
                              }
                           }
                        }
                        // Object type: Difference
                        // Name: Elbow2
                        object
                        {
                           difference
                           {
                              // Object type: Torus
                              // Name: NoName
                              object
                              {
                                 torus { 30, 10 }

                                 scale < 0.5, 0.5, 0.5 >
                                 rotate < 0, 0, -120 >
                                 translate < -25.019, 39.638, -25.991 >
                              }
                              // Object type: Box
                              // Name: NoName
                              object
                              {
                                 box { < 0, 0, 0 >, < 1, 1, 1 > }

                                 scale < 46.406, 15.152, 20.848 >
                                 rotate < 0, 0, -120 >
                                 translate < -20.441, 63.739, -25.773 >
                              }
                              // Object type: Box
                              // Name: NoName
                              object
                              {
                                 box { < 0, 0, 0 >, < 1, 1, 1 > }

                                 scale < 24.648, 20, 49.27 >
                                 rotate < 0, 45, -120 >
                                 translate < -22.244, 59.816, -44.686 >
                              }
                           }
                        }
                        // Object type: Cylinder
                        // Name: NoName
                        object
                        {
                           cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                           scale < 4.924, 51.306, 5 >
                           rotate < 90, 0, 60 >
                           translate < -17.592, 52.502, -26.01 >
                        }
                     }
                  }
                  // Object type: Composite
                  // Name: Side2
                  object
                  {
                     union
                     {
                        // Object type: Cylinder
                        // Name: NoName
                        object
                        {
                           cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                           scale < 5, 100, 5 >
                           rotate < 90, 0, 120 >
                           translate < 44.973, 4.9841, -50 >
                        }
                        // Object type: Difference
                        // Name: Elbow1
                        object
                        {
                           difference
                           {
                              // Object type: Torus
                              // Name: NoName
                              object
                              {
                                 torus { 30, 10 }

                                 scale < 0.5, 0.5, 0.5 >
                                 rotate < 0, 0, 120 >
                                 translate < 37.564, 17.818, -50.128 >
                              }
                              // Object type: Box
                              // Name: NoName
                              object
                              {
                                 box { < 0, 0, 0 >, < 1, 1, 1 > }

                                 scale < 48.222, 17.945, 20.571 >
                                 rotate < 0, 0, 120 >
                                 translate < 58.166, 0.84507, -50.128 >
                              }
                              // Object type: Box
                              // Name: NoName
                              object
                              {
                                 box { < 0, 0, 0 >, < 1, 1, 1 > }

                                 scale < 20, 20, 47.873 >
                                 rotate < 0, -45.233, 120 >
                                 translate < 34.881, 40.354, -69.021 >
                              }
                           }
                        }
                        // Object type: Difference
                        // Name: Elbow1
                        object
                        {
                           difference
                           {
                              // Object type: Torus
                              // Name: NoName
                              object
                              {
                                 torus { 30, 10 }

                                 scale < 0.5, 0.5, 0.5 >
                                 rotate < -180, 0, 120 >
                                 translate < 37.567, 17.813, 50 >
                              }
                              // Object type: Box
                              // Name: NoName
                              object
                              {
                                 box { < 0, 0, 0 >, < 1, 1, 1 > }

                                 scale < 48.222, 17.945, 20.571 >
                                 rotate < -180, 0, 120 >
                                 translate < 41.964, -8.5161, 50 >
                              }
                              // Object type: Box
                              // Name: NoName
                              object
                              {
                                 box { < 0, 0, 0 >, < 1, 1, 1 > }

                                 scale < 20, 20, 47.873 >
                                 rotate < -180, 45.233, 120 >
                                 translate < 19.391, 31.405, 68.893 >
                              }
                           }
                        }
                        // Object type: Cylinder
                        // Name: NoName
                        object
                        {
                           cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                           scale < 4.9625, 34.027, 4.9625 >
                           rotate < 45, 0, 30 >
                           translate < 31.932, 27.572, -60 >
                        }
                        // Object type: Cylinder
                        // Name: NoName
                        object
                        {
                           cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                           scale < 4.909, 35, 4.909 >
                           rotate < -45, 0, 30 >
                           translate < 31.999, 27.456, 60 >
                        }
                        // Object type: Difference
                        // Name: Elbow2
                        object
                        {
                           difference
                           {
                              // Object type: Torus
                              // Name: NoName
                              object
                              {
                                 torus { 30, 10 }

                                 scale < 0.5, 0.5, 0.5 >
                                 rotate < 0, 45, -60 >
                                 translate < 24.836, 39.864, 24.734 >
                              }
                              // Object type: Box
                              // Name: NoName
                              object
                              {
                                 box { < 0, 0, 0 >, < 1, 1, 1 > }

                                 scale < 46.406, 15.152, 20.848 >
                                 rotate < 0, 45, -60 >
                                 translate < 9.722, 49.871, 41.265 >
                              }
                              // Object type: Box
                              // Name: NoName
                              object
                              {
                                 box { < 0, 0, 0 >, < 1, 1, 1 > }

                                 scale < 24.648, 20, 49.27 >
                                 rotate < 60, 90, 0 >
                                 translate < 4.9016, 59.02, 24.853 >
                              }
                           }
                        }
                        // Object type: Difference
                        // Name: Elbow2
                        object
                        {
                           difference
                           {
                              // Object type: Torus
                              // Name: NoName
                              object
                              {
                                 torus { 30, 10 }

                                 scale < 0.5, 0.5, 0.5 >
                                 rotate < 0, 0, -60 >
                                 translate < 24.966, 39.638, -25.991 >
                              }
                              // Object type: Box
                              // Name: NoName
                              object
                              {
                                 box { < 0, 0, 0 >, < 1, 1, 1 > }

                                 scale < 46.406, 15.152, 20.848 >
                                 rotate < 0, 0, -60 >
                                 translate < 6.3834, 55.653, -25.773 >
                              }
                              // Object type: Box
                              // Name: NoName
                              object
                              {
                                 box { < 0, 0, 0 >, < 1, 1, 1 > }

                                 scale < 24.648, 20, 49.27 >
                                 rotate < 1.7075e-06, 45, -60 >
                                 translate < 8.8791, 52.131, -44.686 >
                              }
                           }
                        }
                        // Object type: Cylinder
                        // Name: NoName
                        object
                        {
                           cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                           scale < 4.924, 51.306, 5 >
                           rotate < 90, 0, 120 >
                           translate < 17.539, 52.502, -26.01 >
                        }
                     }
                  }
                  // Object type: Cylinder
                  // Name: NoName
                  object
                  {
                     cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                     scale < 5, 91.466, 5 >
                     rotate < 0, 0, -90 >
                     translate < -46.092, 4.993, -44.567 >
                  }
                  // Object type: Cylinder
                  // Name: NoName
                  object
                  {
                     cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                     scale < 5, 91.583, 5 >
                     rotate < 0, 0, -90 >
                     translate < -45.385, 4.993, 44.664 >
                  }
                  // Object type: Cylinder
                  // Name: NoName
                  object
                  {
                     cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                     scale < 2.6927, 34.647, 2.6927 >
                     rotate < 0, 0, -90 >
                     translate < -17.577, 53.02, -1.4901e-08 >
                  }
               }

               texture
               {
                  DMFWood2
                  scale <25, 25, 25>
						translate < -0.026785, 30.965, 0 >
               }
            }
         }
      }
      // Object type: Composite
      // Name: Balls
      object
      {
         union
         {
            // Object type: Composite
            // Name: Ball1
            object
            {
               union
               {
                  // Object type: Cylinder
                  // Name: NoName
                  object
                  {
                     cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                     scale < 0.36437, 35.433, 0.36437 >
                     rotate < 26.933, -7.9681, 15.261 >
                     translate < -6.3511, 23.735, -35.009 >

                     texture
                     {
                        Glass3
                        scale < 0.36437, 35.433, 0.36437 >
                        rotate < 26.933, -7.9681, 15.261 >
                        translate < -6.3511, 23.735, -35.009 >
                     }
                  }
                  // Object type: Cylinder
                  // Name: NoName
                  object
                  {
                     cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                     scale < 0.364, 35.433, 0.364 >
                     rotate < 26.933, 7.9679, -15.261 >
                     translate < 7.1215, 23.833, -34.969 >

                     texture
                     {
                        Glass3
                        scale < 0.364, 35.433, 0.364 >
                        rotate < 26.933, 7.9679, -15.261 >
                        translate < 7.1215, 23.833, -34.969 >
                     }
                  }
                  // Object type: Sphere
                  // Name: NoName
                  object
                  {
                     sphere { < 0, 0, 0 >, 1 }

                     scale < 7, 7, 7 >
                     rotate < 28.003, 0, 0 >
                     translate < 0.39231, 23.732, -35.011 >

                     texture
                     {
                        Silver1
                        scale < 7, 7, 7 >
                        rotate < 28.003, 0, 0 >
                        translate < 0.39231, 23.732, -35.011 >
                     }
                  }
               }
            }
            // Object type: Composite
            // Name: Ball2
            object
            {
               union
               {
                  // Object type: Sphere
                  // Name: NoName
                  object
                  {
                     sphere { < 0, 0, 0 >, 1 }

                     scale < 7, 7, 7 >
                     translate < 0.39231, 19.994, -5.9555 >

                     texture
                     {
                        Silver1
                        scale < 7, 7, 7 >
                        translate < 0.39231, 19.994, -5.9555 >
                     }
                  }
                  // Object type: Cylinder
                  // Name: NoName
                  object
                  {
                     cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                     scale < 0.36437, 35.433, 0.36437 >
                     rotate < 0, 0, 17.172 >
                     translate < -6.3511, 19.998, -5.9634 >

                     texture
                     {
                        Glass3
                        scale < 0.36437, 35.433, 0.36437 >
                        rotate < 0, 0, 17.172 >
                        translate < -6.3511, 19.998, -5.9634 >
                     }
                  }
                  // Object type: Cylinder
                  // Name: NoName
                  object
                  {
                     cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                     scale < 0.364, 35.433, 0.364 >
                     rotate < 0, 0, -17.172 >
                     translate < 7.018, 20.103, -5.9355 >

                     texture
                     {
                        Glass3
                        scale < 0.364, 35.433, 0.364 >
                        rotate < 0, 0, -17.172 >
                        translate < 7.018, 20.103, -5.9355 >
                     }
                  }
               }
            }
            // Object type: Composite
            // Name: Ball3
            object
            {
               union
               {
                  // Object type: Sphere
                  // Name: NoName
                  object
                  {
                     sphere { < 0, 0, 0 >, 1 }

                     scale < 7, 7, 7 >
                     translate < 0.39231, 19.994, 7.9635 >

                     texture
                     {
                        Silver1
                        scale < 7, 7, 7 >
                        translate < 0.39231, 19.994, 7.9635 >
                     }
                  }
                  // Object type: Cylinder
                  // Name: NoName
                  object
                  {
                     cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                     scale < 0.36437, 35.433, 0.36437 >
                     rotate < 0, 0, 17.172 >
                     translate < -6.3511, 19.998, 7.9642 >

                     texture
                     {
                        Glass3
                        scale < 0.36437, 35.433, 0.36437 >
                        rotate < 0, 0, 17.172 >
                        translate < -6.3511, 19.998, 7.9642 >
                     }
                  }
                  // Object type: Cylinder
                  // Name: NoName
                  object
                  {
                     cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                     scale < 0.364, 35.433, 0.364 >
                     rotate < 0, 0, -17.172 >
                     translate < 6.9921, 20.103, 7.9876 >

                     texture
                     {
                        Glass3
                        scale < 0.364, 35.433, 0.364 >
                        rotate < 0, 0, -17.172 >
                        translate < 6.9921, 20.103, 7.9876 >
                     }
                  }
               }
            }
            // Object type: Composite
            // Name: Ball4
            object
            {
               union
               {
                  // Object type: Cylinder
                  // Name: NoName
                  object
                  {
                     cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                     scale < 0.36437, 35.433, 0.36437 >
                     rotate < 0, 0, 17.172 >
                     translate < -6.3511, 19.997, 21.948 >

                     texture
                     {
                        Glass3
                        scale < 0.36437, 35.433, 0.36437 >
                        rotate < 0, 0, 17.172 >
                        translate < -6.3511, 19.997, 21.948 >
                     }
                  }
                  // Object type: Cylinder
                  // Name: NoName
                  object
                  {
                     cylinder { < 0, 0, 0 >, < 0, 1, 0 >, 1 open }

                     scale < 0.364, 35.433, 0.364 >
                     rotate < 0, 0, -17.172 >
                     translate < 7.018, 20.103, 21.988 >

                     texture
                     {
                        Glass3
                        scale < 0.364, 35.433, 0.364 >
                        rotate < 0, 0, -17.172 >
                        translate < 7.018, 20.103, 21.988 >
                     }
                  }
                  // Object type: Sphere
                  // Name: NoName
                  object
                  {
                     sphere { < 0, 0, 0 >, 1 }

                     scale < 7, 7, 7 >
                     translate < 0.39231, 19.994, 21.964 >

                     texture
                     {
                        Silver1
                        scale < 7, 7, 7 >
                        translate < 0.39231, 19.994, 21.964 >
                     }
                  }
               }
            }
         }
      }